-- UP script for initial-schema (20190214122514)
create extension if not exists "uuid-ossp";

create table "users" (
  id uuid default uuid_generate_v4() primary key,
  display_name varchar not null,
  email varchar not null unique,
  hashed_pwd varchar not null,
  salt varchar not null
);

create table "api_tokens" (
  id uuid default uuid_generate_v4() primary key,
  user_id uuid not null references users (id) on delete cascade on update cascade,
  name varchar not null,
  expires timestamp with time zone default null,
  hashed_token varchar not null
);

create table "measures" (
  id uuid default uuid_generate_v4() primary key,
  user_id uuid not null references users (id) on delete cascade on update cascade,
  slug varchar not null,
  name varchar not null,
  description varchar not null default '',
  domain_source varchar default null ,
  domain_units varchar not null default '',
  range_source varchar default null,
  range_units varchar not null default '',
  analysis varchar[] not null default '{}'
);

create table "values" (
  id uuid default uuid_generate_v4() primary key,
  measure_id uuid not null references measures (id) on delete cascade on update cascade,
  value integer not null,
  "timestamp" timestamp not null default current_timestamp,
  ext_data jsonb not null default '{}'::json
);
